<?php
#####rrbranchesqueue_dbsetup.php, installed by ###Admin Branches Queue, by Robin Richmond:
# Creates or deletes Branch table fields for the Branch Timestamps mod.
# 1. datefinished - When the last operation on the branch was finished. Default="00000-00-00"
#    Is not changed by the Person or Family editor when a changes a branch label in a
#    Person or Family records while editing that record.
# 2. actionfinished - The last operation performed on the branch (add, delete, clear)
# 3. people - The number of Person records processed. Set when the operation finishes.
# 4. families - The number of Family records processed. Set when the operation finishes.
#    Note that the people and families values are not updated if a clear operation uses
#    the "complete" option; it is only set when the operation traverses the tree by following
#    ancestor and descendant links.
# 5. datequeued - When an operation is queued in a batch, this date/time stamp is set,
#    along with the actionrequested
# 6. datestarted - When processing of the branch is actually started, this date/time stamp is set.
# 7. username - The username of the user who queued or started a branch operation.
# 8. actionrequested - The last operation that has been queued or started (add, delete, clear)
#
# This setup program is installed by the Admin Branches Queue mod, and must be run from
# the Admin Branches Queue mod description within the Mod Manager.
#
# This program lists each fieldname, notes whether that field exists, counts fields that
# already exist, and then displays  "Create fields" and/or "Remove fields" buttons, based
# on the count of existing fields.
# It uses an array of field specifications.
# There are 8 new fields, so the array fieldspecs will have 8 elements.
# Each fielspecs element has 4 array elements of its own, for
# 0 - The table name,
# 1 - The field name,
# 2 - The data type
# 3 - Additional attributes to be placed in an ALTER TABLE command, such as "NOT NULL"
#     and the default value.
$tngModNames['Admin Branches Queue']['rrbranchesqueue_dbsetup.php'] = '5';
#################################################################

include("begin.php");
include($cms['tngpath'] ."adminlib.php");
$textpart = "textplus";
include($cms['tngpath'] ."getlang.php");
include($cms['tngpath'] ."$mylanguage/admintext.php");

#Read custom language strings from a mod subfolder rather than from regular cust_text.php files.
$modfolder = $admtext['rrbq-modfolder'];
if (file_exists("$modspath/$modfolder/{$mylanguage}_cust_text.php"))
	include("$modspath/$modfolder/{$mylanguage}_cust_text.php");
else include("$modspath/$modfolder/languages/English_cust_text.php");

$admin_login = 1;
include($cms['tngpath'] ."checklogin.php");
include($cms['tngpath'] ."version.php");
#require($cms['tngpath'] ."adminlog.php");

$flags['tabs'] = $tngconfig['tabs'];
tng_adminheader( $admtext['rrbq-heading1'], $flags );
echo "</head>\n";

echo "<body background='{$cms['tngpath']}img/background.gif'>\n";
$menu = doMenu('','','');
echo displayHeadline($admtext['rrbq-heading1'] , "img/branches_icon.gif",$menu,$message);
?>

<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow normal">
<?php
	$fieldspecs[] = array($branches_table,'datefinished','DATETIME',"NOT NULL DEFAULT '0000-00-00'");
	$fieldspecs[] = array($branches_table,'actionfinished','VARCHAR(10)',"NOT NULL DEFAULT ''");
	$fieldspecs[] = array($branches_table,'people','INT(11)','NOT NULL DEFAULT 0');
	$fieldspecs[] = array($branches_table,'families','INT(11)','NOT NULL DEFAULT 0');
	$fieldspecs[] = array($branches_table,'datequeued','DATETIME','');
	$fieldspecs[] = array($branches_table,'datestarted','DATETIME','');
	$fieldspecs[] = array($branches_table,'username','VARCHAR(20)',"NOT NULL DEFAULT ''");
	$fieldspecs[] = array($branches_table,'actionrequested','VARCHAR(10)',"NOT NULL DEFAULT ''");

	//Before displaying the form, take any action that was specified by button b1
	if ($b1 == $admtext['rrbq-setup']) {
		#Create fields
		for ($i=0; $i<count($fieldspecs); $i++) {
			if ($_GET["fieldstatus$i"] == 'no') createField($fieldspecs[$i]);
		}
	} elseif ($b1 == $admtext['rrbq-remove']) {
		#Deletefields
		for ($i=0; $i<count($fieldspecs); $i++) {
			if ($_GET["fieldstatus$i"] == 'yes') removeField($fieldspecs[$i]);
		}
	}
	# End of actions

	$countExisting = 0;
	echo "<form>\n";
	echo "<table cellpadding='3' cellspacing='1' border='0' class='normal'>
		<thead><tr class='fieldnameback fieldname'>
			<th class='fieldnameback'>Table</th>
			<th class='fieldnameback'>New Field</th>
			<th class='fieldnameback'>Exists</th>
		</tr></thead>
		<tbody>\n";
	for ($i=0; $i<count($fieldspecs); $i++) {
		echo "<tr><td class='lightback'>{$fieldspecs[$i][0]}</td>
			<td class='lightback'>{$fieldspecs[$i][1]}</td>\n";
		if ( checkField( $fieldspecs[$i][0], $fieldspecs[$i][1])) {
			$myvalue='yes';
			$countExisting++;
		}
		else $myvalue='no';
		echo "			<td class='lightback center'>$myvalue
			<input type='hidden' name='fieldstatus$i' value='$myvalue'> </td></tr>\n";
	}
	echo "</tbody></table>\n";
	if ($countExisting < count($fieldspecs))
		echo "&nbsp;&nbsp;<input type='submit' name='b1' value=\"{$admtext['rrbq-setup']}\">";
	if ($countExisting >0)
		echo "&nbsp;&nbsp;<input type='submit' name='b1' value=\"{$admtext['rrbq-remove']}\">";
	echo "&nbsp;&nbsp<a href=\"{$_SERVER['SCRIPT_NAME']}\">Reload page</a>\n";
	echo "</form>
	<p style='font-weight:bold;'>{$admtext['rrbq-close']}</p>\n";
?>
</td>
</tr>
</table>
<?php
	if (file_exists('rrshowmodnames_include.php')) include_once ('rrshowmodnames_include.php'); # Display hyperlinked list of mods
?>
<?php echo "<div align=\"right\"><span class=\"normal\">$tng_title, v.$tng_version</span></div>"; ?>
</body>
</html>

<?php
##############################################################################
################## End of Mainline code; PHP Functions follow ################
##############################################################################

# Function to create a field if it doesn't already exist.
# It displays a message showing the fieldname and "...Done"
# I haven't figured out how to check for or suppress errors, so the program will
# crash if there is a problem creating the field.
# The function parameter is an array with the table and field names in the first two numbered array elements.
function createField($fieldspec) {
	global $admtext;
	if (!checkField( $fieldspec[0], $fieldspec[1])) {
		$query = "ALTER TABLE {$fieldspec[0]} ADD {$fieldspec[1]} {$fieldspec[2]} {$fieldspec[3]}
				COMMENT 'Created by Admin Branches Queue'";
		echo "<div>Creating {$fieldspec[0]}.{$fieldspec[1]} \n";
		$result = @tng_query($query);
		echo "...{$admtext['rrbbt-done']}</div>\n";
	}
}

##############################################################################
# Function to delete a field if it exists.
# Displays a message showing the fieldname and "...Done"
# I haven't figured out how to check for or suppress errors, so the program will
# crash if there is a problem dropping the field.
# The function parameter is an array of field specifications:
# 0 - The table name,
# 1 - The field name,
# 2 - The data type
# 3 - Additional attributes to be placed in an ALTER TABLE command, such as "NOT NULL"
#     and the default value.
function removeField($fieldspec) {
	global $admtext;
	if (checkField( $fieldspec[0], $fieldspec[1])) {
		$query = "ALTER TABLE {$fieldspec[0]} DROP {$fieldspec[1]}";
		echo "<div>Dropping {$fieldspec[0]}.{$fieldspec[1]} ";
		$result = @tng_query($query);
		if( $result )
			echo "...{$admtext['done']}</div>\n";
		else echo "...<strong>{$admtext['rrbq-notdeleted']}</strong></div>\n";
	}
}

##############################################################################
# This function returns a boolean flag that is true if the field exists.
function checkField($table, $fieldname) {
	global $admtext;
	$query = "SHOW columns FROM $table WHERE field = '$fieldname'";
	$result = tng_query($query);
	$fieldIsPresent = (tng_num_rows($result) == 1);
	tng_free_result($result);
	return $fieldIsPresent;
}
?>