<?php
#####rrbranchesqueue_status.php, installed by ###Admin Branches Queue, by Robin Richmond:
# This AJAX program checks the status of processes that have been queued to add or clear branch labels.
#Input querystring parameters:
# $tree - The tree the branch is in
# $branch - A branch name
# $branchlist - A list of branches to check, each within single quotes, comma separated
#               (i.e. formatted for a SQL IN condition)
# $details - 1 to get a count of labels in the branch.
# When there is a branch list, this program specifically checks the branches in the list,
# When there is a only a branchID, this program checks it, plus all branches that feed it.

#Output - An HTML string with
#  - The current date/time,
#  - an ordered list of the branch names with the time they were queued or started, and
#  - the word "Done!" (in the current language) if all are completed.
$tngModNames['Admin Branches Queue']['rrbranchesqueue_status.php'] = '5'; #Register this mod
#######################################################################

include("begin.php");
include("adminlib.php");
$textpart = "branches";
include($cms['tngpath'] ."getlang.php");
include($cms['tngpath'] ."$mylanguage/admintext.php");

#Read custom language strings from a mod subfolder rather than from regular cust_text.php files.
$modfolder = $admtext['rrbq-modfolder'];
if (file_exists("$modspath/$modfolder/{$mylanguage}_cust_text.php"))
	include("$modspath/$modfolder/{$mylanguage}_cust_text.php");
else include("$modspath/$modfolder/languages/English_cust_text.php");

include("checklogin.php");

@set_time_limit(0);

if ($branchlist) $branchSQL = "branch IN ($branchlist)";
else $branchSQL = "branch LIKE '%$branch%'";
$query = "SELECT branch, b.description, actionrequested, datestarted, datequeued, lastimportdate
	FROM $branches_table b INNER JOIN $trees_table t ON t.gedcom=b.gedcom
	WHERE b.gedcom = '$tree' AND $branchSQL
		AND datequeued IS NOT NULL or datestarted IS NOT NULL";
$result = tng_query($query);

header("Content-type:text/html; charset=" . $session_charset);
echo "{$admtext['rrbq-at']} <span id='branchcheckdate'>", date('d M Y h:i:s A', time()), "</span>\n";

if (tng_num_rows($result)) {
	# One or more branches related to the starting branch are still in queue or in process
	echo "<ul style='margin-top:0;margin-bottom:0;'>\n";
	while( $brow = tng_fetch_assoc($result)) {
		echo "{$admtext['branch']} {$brow['branch']}; {$brow['description']}: ";
		if ($brow['datestarted']) {
			#Actively being rebuilt
			echo $brow['actionrequested'], ' ', $admtext['rrbq-actionstarted'] , ' ', date('d M Y H:i', strtotime($brow['datestarted'])),'<br/>';
			if ($details) {
				$query = "SELECT
					(SELECT count(*) FROM $branchlinks_table WHERE branch='%$branch%' AND persfamID LIKE '{$tngconfig['personprefix']}%') AS people,
					(SELECT count(*) FROM $families_table WHERE branch LIKE '%$branch%' AND persfamID LIKE '{$tngconfig['familyprefix']}%') AS families";
				$dresult = tng_query($query);
				$drow = tng_fetch_assoc($result);
				echo "&nbsp;&nbsp;&nbsp;&nbsp;{$drow['people']} {$admtext['people']}, {$drow['families']} {$admtext['families']}<br/>\n";
			}
		}
		elseif ($brow['datequeued']){
			$allBranchesAreUpToDate = false;
			echo $brow['actionrequested'], ' ', $admtext['rrbq-actionqueued'] , ' ', date('d M Y H:i', strtotime($brow['datequeued'])),'<br/>';
		}
	} #end of loop through the branches
	echo "</ul>\n";
}
else #No results; all branches are finished
	echo "<div id='done'>{$admtext['rrbq-done']}</div>\n";

tng_free_result( $result );
?>